# THIS FILE IS AUTOMATICALLY GENERATED BY CARGO
#
# When uploading crates to the registry Cargo will automatically
# "normalize" Cargo.toml files for maximal compatibility
# with all versions of Cargo and also rewrite `path` dependencies
# to registry (e.g., crates.io) dependencies.
#
# If you are reading this file be aware that the original Cargo.toml
# will likely look very different (and much more reasonable).
# See Cargo.toml.orig for the original contents.

[package]
edition = "2021"
name = "bgpkit-broker"
version = "0.10.0"
authors = ["Mingwei Zhang <mingwei@bgpkit.com>"]
build = false
autolib = false
autobins = false
autoexamples = false
autotests = false
autobenches = false
description = """
A library and command-line to provide indexing and searching functionalities for public BGP data archive files over time.
"""
documentation = "https://docs.rs/bgpkit-broker"
readme = "README.md"
keywords = [
    "bgp",
    "bgpkit",
    "api",
]
license = "MIT"
repository = "https://github.com/bgpkit/bgpkit-broker"

[package.metadata.binstall]
pkg-url = "{ repo }/releases/download/v{ version }/{ name }-{ target }.tar.gz"
pkg-fmt = "tgz"

[features]
backend = [
    "tokio",
    "sqlx",
]
cli = [
    "clap",
    "dirs",
    "humantime",
    "num_cpus",
    "tracing-subscriber",
    "tabled",
    "itertools",
    "tempfile",
    "which",
    "bgpkit-commons",
    "futures",
    "oneio",
    "regex",
    "scraper",
    "tokio",
    "nats",
    "backend",
    "indicatif",
    "futures-util",
    "axum",
    "axum-prometheus",
    "http",
    "tower-http",
]
default = []
nats = ["async-nats"]

[lib]
name = "bgpkit_broker"
path = "src/lib.rs"

[[bin]]
name = "bgpkit-broker"
path = "src/cli/main.rs"
required-features = ["cli"]

[[example]]
name = "health_check"
path = "examples/health_check.rs"

[[example]]
name = "latest"
path = "examples/latest.rs"

[[example]]
name = "peers"
path = "examples/peers.rs"

[[example]]
name = "query"
path = "examples/query.rs"

[[example]]
name = "shortcuts"
path = "examples/shortcuts.rs"

[[example]]
name = "simple_config"
path = "examples/simple_config.rs"

[[example]]
name = "timestamps"
path = "examples/timestamps.rs"

[dependencies.async-nats]
version = "0.42.0"
optional = true

[dependencies.axum]
version = "0.8"
optional = true

[dependencies.axum-prometheus]
version = "0.9.0"
optional = true

[dependencies.bgpkit-commons]
version = "0.9.2"
features = [
    "mrt_collectors",
    "countries",
]
optional = true
default-features = false

[dependencies.chrono]
version = "0.4"
features = ["serde"]

[dependencies.clap]
version = "4.3"
features = ["derive"]
optional = true

[dependencies.dirs]
version = "6"
optional = true

[dependencies.dotenvy]
version = "0.15"

[dependencies.futures]
version = "0.3"
optional = true

[dependencies.futures-util]
version = "0.3.28"
optional = true

[dependencies.http]
version = "1.0"
optional = true

[dependencies.humantime]
version = "2.1"
optional = true

[dependencies.indicatif]
version = "0.18.0"
optional = true

[dependencies.itertools]
version = "0.14.0"
optional = true

[dependencies.lazy_static]
version = "1"

[dependencies.log]
version = "0.4"

[dependencies.num_cpus]
version = "1.15"
optional = true

[dependencies.oneio]
version = "0.20.0"
features = [
    "https",
    "s3",
]
optional = true
default-features = false

[dependencies.regex]
version = "1"
optional = true

[dependencies.reqwest]
version = "0.12"
features = [
    "blocking",
    "json",
    "stream",
    "rustls-tls-native-roots",
]
default-features = false

[dependencies.scraper]
version = "0.24"
optional = true

[dependencies.serde]
version = "1"
features = ["derive"]

[dependencies.serde_json]
version = "1"

[dependencies.sqlx]
version = "0.8"
features = [
    "runtime-tokio",
    "sqlite",
]
optional = true

[dependencies.tabled]
version = "0.20.0"
optional = true

[dependencies.tempfile]
version = "3.8"
optional = true

[dependencies.thiserror]
version = "2.0"

[dependencies.tokio]
version = "1"
features = ["full"]
optional = true

[dependencies.tower-http]
version = "0.6"
features = ["cors"]
optional = true

[dependencies.tracing]
version = "0.1"

[dependencies.tracing-subscriber]
version = "0.3"
optional = true

[dependencies.which]
version = "8.0.0"
optional = true

[dev-dependencies.tracing-subscriber]
version = "0.3.17"

[lints.clippy]
uninlined_format_args = "allow"
unwrap_used = "deny"
